-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     03/05/2022  09:24
--   Issue:          381152 - [HCM] - Trigger Excluindo Resumo de Situação de Frequência para marcações que estão definidas como FS (está considerando somente o dia e não o tipo da marcação)
-- ============================================================

-- ============================================================
--   Trigger: PTO_DROPRESUMOSITUFREQ                                      
-- ============================================================
CREATE OR REPLACE TRIGGER PTO_DROPRESUMOSITUFREQ
 AFTER INSERT OR UPDATE OR DELETE
 ON GPE_MARCACAOPONTO FOR EACH ROW
BEGIN
  IF (INSERTING OR UPDATING) AND :NEW.NRCOLETOR = 24 THEN
    DELETE FROM PTO_RESUMOSITUFREQ R
    WHERE R.NRORG              = :NEW.NRORG
      AND R.NRVINCULOM         = :NEW.NRVINCULOM
      AND R.DTAPURACAOSITUFREQ = (
        CASE WHEN :NEW.IDDIAOCORRENCIA IN ('FS', 'DS') THEN
            TRUNC(:NEW.DTHRAJUSTADA, 'DD') + 1
        WHEN :NEW.IDDIAOCORRENCIA IN ('FA', 'DA') THEN
            TRUNC(:NEW.DTHRAJUSTADA, 'DD') - 1
        ELSE TRUNC(:NEW.DTHRAJUSTADA, 'DD') END
      )
      ;
  ELSIF DELETING AND :OLD.NRCOLETOR = 24 THEN
    DELETE FROM PTO_RESUMOSITUFREQ R
    WHERE R.NRORG              = :OLD.NRORG
      AND R.NRVINCULOM         = :OLD.NRVINCULOM
      AND R.DTAPURACAOSITUFREQ = (
        CASE WHEN :OLD.IDDIAOCORRENCIA IN ('FS', 'DS') THEN
            TRUNC(:OLD.DTHRAJUSTADA, 'DD') + 1
        WHEN :OLD.IDDIAOCORRENCIA IN ('FA', 'DA') THEN
            TRUNC(:OLD.DTHRAJUSTADA, 'DD') - 1
        ELSE TRUNC(:OLD.DTHRAJUSTADA, 'DD') END
      );
  END IF;
END;
/